     /********************************************************************/     
     /* SQL2XLXR - Create Excel from SQL - >> POI-Jakarta  <<            */     
     /********************************************************************/     
                                                                                
     H Dftactgrp(*NO) Actgrp('XLXR') BNDDIR('QC2LE') debug                      
     H Copyright('giuseppe.costagliola@gmail.com - 2017')                       
                                                                                
      //-------------------------------------------------------------------     
      // Parameters                                                             
      //-------------------------------------------------------------------     
     DSQL2XLSXRO       PR                                                       
     D pSQLSTMT                    5000                                         
     D pTOXLS                       120                                         
     D pFROMXLS                     120                                         
     D pSQLID                       120                                         
     DSQL2XLSXRO       PI                                                       
     D pSQLSTMT                    5000                                         
     D pTOXLS                       120                                         
     D pFROMXLS                     120                                         
     D pSQLID                       120                                         
                                                                                
      /COPY QSYSINC/QRPGLESRC,QUSEC                                             
     DQUSED01                        60                                         
                                                                                
      // Stream file APIs --------------------------------------------------.   
     Dunlink           PR             9B 0 EXTPROC('unlink')                    
     D                                 *   VALUE                                
     Dopen             PR            10I 0 EXTPROC('open')                      
     D                                 *   VALUE                                
     D                               10I 0 VALUE                                
     D                               10U 0 VALUE OPTIONS(*NOPASS)               
     D                               10U 0 VALUE OPTIONS(*NOPASS)               
     D O_CREAT         S             10I 0 INZ(8)                               
     D O_WRONLY        S             10I 0 INZ(2)                               
     D O_TRUNC         S             10I 0 INZ(64)                              
     D O_CODEPAGE      S             10I 0 INZ(8388608)                         
     D S_IRWXU         S             10I 0 INZ(448)                             
     D S_IROTH         S             10I 0 INZ(4)                               
     Dwrite            PR            10I 0 EXTPROC('write')                     
     D                               10I 0 VALUE                                
     D                                 *   VALUE                                
     D                               10I 0 VALUE                                
     Dclose            PR            10I 0 EXTPROC('close')                     
     D                               10I 0 VALUE                                
      //                                                                        
     Dfd               S             10I 0                                      
     Dbytesw           S             10I 0                                      
                                                                                
      // Local procedures --------------------------------------------------    
     DRftSQLstmt       PR                  likeds(SQL)                          
     D SQLstmt                             value like(pSQLstmt)                 
                                                                                
     DCrtSQLstmf       PR                  like(SQL.id)                         
     D JobId                               value like(JobNbr)                   
                                                                                
     DWrtSQLstmt       PR                                                       
     D pSQL                                value likeds(SQL)                    
                                                                                
     DFixPath          PR           128                                         
     D Path                         128    value                                
                                                                                
     DEbcdic2Ascii     PR                                                       
     D from                            *   Value                                
     D len                           10i 0 Value                                
                                                                                
     DGetErrInfo       PR           128                                         
                                                                                
     DSndPgmMsg        PR                                                       
     D type                          10A   VALUE                                
     D function                      20A   VALUE                                
     D msgId                          7A   VALUE                                
     D msg                          128A   VALUE                                
                                                                                
      // Local variables ---------------------------------------------------    
     Dmsg              S            128                                         
     DPath             S            128                                         
     Dbuffer           S             10i 0                                      
                                                                                
      // Local structures --------------------------------------------------    
     DSQL              DS                  Qualified                            
     D Stmt                                like(pSQLSTMT)                       
     D Length                        10I 0                                      
     D Id                           120A                                        
                                                                                
      // Program status ----------------------------------------------------    
     DPgmSts          SDS                  NoOpt                                
     D JobNbr                         6a   Overlay(PgmSts:264)                  
                                                                                
      //********************************************************************    
      // MAIN                                                                   
      //********************************************************************    
                                                                                
      /free                                                                     
                                                                                
       // Reformat the SQL statement                                            
       SQL = RftSQLstmt (pSQLSTMT);                                             
                                                                                
       // Create the SQLstatement stream file                                   
       SQL.id = CrtSQLstmf (JobNbr);                                            
                                                                                
       // Write the SQL statement                                               
       WrtSQLstmt (SQL);                                                        
                                                                                
       // Fix path names                                                        
       Path = FixPath (pTOXLS);                                                 
       pTOXLS = Path;                                                           
       Path = FixPath (pFROMXLS);                                               
       pFROMXLS = Path;                                                         
                                                                                
       // Return SQL stream file ID                                             
       pSQLID = SQL.Id;                                                         
       *inlr = *on;                                                             
       return;                                                                  
                                                                                
      /end-free                                                                 
                                                                                
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
      // Reformat the SQL statement                                             
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
     PRftSQLstmt       B                                                        
     DRftSQLstmt       PI                  likeds(SQL)                          
     D SQLstmt                             value like(pSQLstmt)                 
                                                                                
     D NewSQL          DS                  likeds(SQL)                          
     D j               s              5I 0                                      
                                                                                
      /free                                                                     
                                                                                
       NewSQL.Stmt = SQLstmt;                                                   
       NewSQL.Length = %len(%trim(SQLStmt));                                    
       for j = 1 to NewSQL.Length;                                              
         select;                                                                
           when %subst(NewSQL.Stmt:j:1) = '"';                                  
             %subst(NewSQL.Stmt:j:1) = '''';                                    
           when %subst(NewSQL.Stmt:j:1) = '[';                                  
             %subst(NewSQL.Stmt:j:1) = '"';                                     
           when %subst(NewSQL.Stmt:j:1) = ']';                                  
             %subst(NewSQL.Stmt:j:1) = '"';                                     
         endsl;                                                                 
       endfor;                                                                  
                                                                                
       // return SQL structure                                                  
       return NewSQL;                                                           
                                                                                
      /end-free                                                                 
                                                                                
     PRftSQLstmt       E                                                        
                                                                                
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
      // Create an empty SQL parameter file                                     
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
     PCrtSQLstmf       B                                                        
     DCrtSQLstmf       PI                  like(SQL.id)                         
     D Jobid                          6A   Value                                
                                                                                
     DFileName         S                   like(SQL.id)                         
     DErrMsg           S            128A                                        
                                                                                
      /free                                                                     
                                                                                
       FileName = '/tmp/SQLID' + %trim(JobId) + '.dat';                         
       FileName = %TRIM(FileName) + X'00';                                      
                                                                                
       // Check whether stream file exists or not.                              
       fd = open(%Addr(FileName) : 1);                                          
                                                                                
       // If Stream file exists, then unlink the stream file                    
       If fd <> -1;                                                             
         If close(fd) = -1;                                                     
           ErrMsg = 'close() failed. ' + geterrinfo;                            
         EndIf;                                                                 
         If unlink(%Addr(Filename)) = -1;                                       
           ErrMsg = 'unlink() failed. ' + geterrinfo;                           
         Endif;                                                                 
       EndIf;                                                                   
                                                                                
       // if errors exit                                                        
       if ErrMsg <> ' ';                                                        
         SndPgmMsg ('*ESCAPE':'CrtSQLstmf': ' ' : ErrMsg);                      
       Endif;                                                                   
                                                                                
       // Open(Create) stream file                                              
       fd = open(%Addr(Filename)                                                
            : O_CREAT + O_WRONLY + O_TRUNC + O_CODEPAGE                         
            : S_IRWXU + S_IROTH : 819);                                         
       If fd = -1;                                                              
         ErrMsg = 'open() failed. ' + geterrinfo;                               
       EndIf;                                                                   
                                                                                
       // if errors exit                                                        
       if ErrMsg <> ' ';                                                        
         SndPgmMsg ('*ESCAPE':'CrtSQLstmt': ' ' : ErrMsg);                      
       Endif;                                                                   
                                                                                
       // return SQLid                                                          
       return Filename;                                                         
                                                                                
      /end-free                                                                 
                                                                                
     PCrtSQLstmf       E                                                        
                                                                                
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
      // Write the statement                                                    
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
     PWrtSQLstmt       B                                                        
     DWrtSQLstmt       PI                                                       
     D pSql                                value likeds(SQL)                    
                                                                                
     DErrMsg           S            128A                                        
                                                                                
      /free                                                                     
                                                                                
       // convert to ascii                                                      
       Ebcdic2Ascii (%addr(pSQL.Stmt):pSQL.Length);                             
                                                                                
       // write data to stream file                                             
       bytesw = write(fd:%addr(pSQL.stmt):pSQL.Length);                         
       If bytesw <> pSQL.Length;                                                
         ErrMsg = 'write() failed. ' + geterrinfo;                              
       Endif;                                                                   
                                                                                
       // close stream file                                                     
       If close(fd) = -1;                                                       
         ErrMsg = 'close() failed. ' + geterrinfo;                              
         SndPgmMsg ('*ESCAPE':'CloSQLstmt': ' ' : ErrMsg);                      
       EndIf;                                                                   
                                                                                
      /end-free                                                                 
                                                                                
     PWrtSQLstmt       E                                                        
                                                                                
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
      // Fix Path names                                                         
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
     PFixPath          B                                                        
     DFixPath          PI           128                                         
     D Path                         128    value                                
                                                                                
     D i               S              5I 0                                      
                                                                                
      /free                                                                     
                                                                                
       // put backslash in IFS style                                            
       Path = %trim(Path);                                                      
       If %scan('\':Path) > 0;                                                  
         For i=1 to %len(%trimr(Path));                                         
           if %subst(Path:i:1) = '\';                                           
             %subst(Path:i:1) = '/';                                            
           endif;                                                               
         EndFor;                                                                
       EndIf;                                                                   
                                                                                
       return Path;                                                             
                                                                                
      /end-free                                                                 
                                                                                
     PFixPath          E                                                        
                                                                                
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
      // Ebcdic -> Ascii                                                        
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
     PEbcdic2Ascii     B                                                        
     DEbcdic2Ascii     PI                                                       
     D from                            *   Value                                
     D len                           10i 0 Value                                
                                                                                
      // Convert a Graphic Character String API                                 
     DCDRCVRT          PR                  extpgm('CDRCVRT')                    
     D CCSID1                        10I 0 const                                
     D ST1                           10I 0 const                                
     D S1                           256    const                                
     D L1                            10I 0 const                                
     D CCSID2                        10I 0 const                                
     D ST2                           10I 0 const                                
     D GCCASN                        10I 0 const                                
     D L2                            10I 0 const                                
     D S2                           256                                         
     D L3                            10I 0                                      
     D L4                            10I 0                                      
     D FB                            12                                         
                                                                                
      // xlateb MI                                                              
     Dxlateb           PR                  EXTPROC('_XLATEB')                   
     D                                 *   VALUE                                
     D                                 *   VALUE                                
     D                               10u 0 VALUE                                
                                                                                
     DQUSRJOBI         PR                  extpgm('QUSRJOBI')                   
     D jobi0400                    1024    options(*varsize)                    
     D jobiBytes                      9B 0 const                                
     D jobiFormat                    10    const                                
     D jobiJobName                   26    const                                
     D jobiJobInt                    16    const                                
     D ApiError                     120    options(*varsize)                    
     D jobi0400        DS                                                       
     D  CCSID                         9B 0 overlay(jobi0400:373)                
                                                                                
      // conversion tables and CDRCVRT rtn flds                                 
     DTblEbcdic        s            256    inz(*allx'ff')                       
     DTblAscii         s            256    inz(*allx'ff')                       
     DL3               s             10i 0                                      
     DL4               s             10i 0                                      
     DFB               s             12                                         
                                                                                
      // conversion binary - hex                                                
     dxValue           ds                                                       
     d bValue                         3U 0                                      
                                                                                
      /free                                                                     
        // get CCSID                                                            
        QUSRJOBI (jobi0400:%len(jobi0400):'JOBI0400':'*':' ':QUSEC);            
        // create a conversion table                                            
        for bValue = 0 to 254;                                                  
          %subst(TblEbcdic:bValue+1:1) = xValue;                                
        endfor;                                                                 
        CDRCVRT (CCSID:0:TblEbcdic:256:819:0:0:256:TblAscii:L3:L4:FB);          
        // convert                                                              
        xlateb (from:%addr(TblAscii):len);                                      
      /end-free                                                                 
                                                                                
     PEbcdic2Ascii     E                                                        
                                                                                
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
      // Get C error data                                                       
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
     Pgeterrinfo       B                                                        
     Dgeterrinfo       PI           128                                         
     Dgeterrno         PR              *   EXTPROC('__errno')                   
     Dstrerror         PR              *   EXTPROC('strerror')                  
     D errno                         10I 0 VALUE                                
     Derrnum           S             10I 0 BASED(errnum_p)                      
      /free                                                                     
       errnum_p = geterrno;                                                     
       Return %TRIM(%EDITC(errnum : '3')) + ' : ' +                             
           %STR(strerror(errnum));                                              
      /end-free                                                                 
     Pgeterrinfo       E                                                        
                                                                                
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
      // Send Program Message                                                   
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
     PSndPgmMsg        B                                                        
     DSndPgmMsg        PI                                                       
     D msgType                       10A   VALUE                                
     D function                      20A   VALUE                                
     D msgId                          7A   VALUE                                
     D msgErr                       128A   VALUE                                
                                                                                
     D QMHSNDPM        PR                  extpgm('QMHSNDPM')                   
     D  MessageId                     7    const                                
     D  MessageFile                  20    const                                
     D  MessageData                 512    const options(*varsize)              
     D  MessageDataL                  9b 0 const                                
     D  MessageType                  10    const                                
     D  CallStkEntry                128    const options(*varsize)              
     D  CallStkCount                  9b 0 const                                
     D  MessageKey                    4    const                                
     D  ApiError                    120    options(*varsize)                    
                                                                                
     D idMsg           S              7A                                        
     D errMsg          S            128A                                        
                                                                                
      /free                                                                     
                                                                                
       if msgId <> ' ';                                                         
         idMsg  = msgId;                                                        
         errMsg = msgErr;                                                       
       else;                                                                    
         if msgType = '*ESCAPE';                                                
           idMsg  = 'CPF9898';                                                  
           errMsg = 'Error ' + %trimr(function) + ' : ' + msgErr;               
         else;                                                                  
           errMsg = msgErr;                                                     
         endif;                                                                 
       endif;                                                                   
                                                                                
       QMHSNDPM (idMsg: 'QCPFMSG   QSYS' : errMsg : %len(errMsg) :              
                 msgType : '*CTLBDY' : 1 : ' ' : QUSEC);                        
                                                                                
      /end-free                                                                 
     PSndPgmMsg        E                                                        
